class HelloWorldMail < ActionMailer::Base
  # email is a TMail::Mail
  def receive(email)
    #email.attachments are TMail::Attachment
    #but they ignore a text/mail parts.d
    tmp_dir = "#{RAILS_ROOT}/tmp"
    idx = 1
    email.parts.each do |part|
      filename = part_filename(part)
      filename = "#{idx}.#{ext(part)}" if filename.nil? || filename.length == 0
      filepath = tmp_dir + '/' + filename
      puts "WRITING: #{filepath}"
      File.open(filepath,File::CREAT|File::TRUNC|File::WRONLY,0644){ |f|
        f.write(part.body)
      }
      idx += 1
    end
  end

  # part is a TMail::Mail
  def part_filename(part)
    # This is how TMail::Attachment gets a filename
    file_name = (part['content-location'] &&
      part['content-location'].body) ||
      part.sub_header("content-type", "name") ||
      part.sub_header("content-disposition", "filename")
  end

  CTYPE_TO_EXT = {
    'image/jpeg' => 'jpg',
    'image/gif'  => 'gif',
    'image/png'  => 'png',
    'image/tiff' => 'tif'
  }

  def ext( mail )
    CTYPE_TO_EXT[mail.content_type] || 'txt'
  end
end
