require File.dirname(__FILE__) + '/../test_helper'
require 'hello_world_mail'

class HelloWorldMailTest < Test::Unit::TestCase
  FIXTURES_PATH = File.dirname(__FILE__) + '/../fixtures'
  CHARSET = "utf-8"

  include ActionMailer::Quoting

  def setup
    ActionMailer::Base.delivery_method = :test
    ActionMailer::Base.perform_deliveries = true
    ActionMailer::Base.deliveries = []

    @expected = TMail::Mail.new
    @expected.set_content_type "text", "plain", { "charset" => CHARSET }
  end

  def test_hello_world
      email_text = read_fixture('hello-world.mail').join
      HelloWorldMail.receive(email_text)
  end

  private
    def read_fixture(action)
      IO.readlines("#{FIXTURES_PATH}/hello_world_mail/#{action}")
    end

    def encode(subject)
      quoted_printable(subject, CHARSET)
    end
end
